#ifndef ARRAYS_HH
#define ARRAYS_HH

#include <vector>

#include <assert.h>

#include <iostream>

using namespace std;

template<class T>
class array2 : private vector<T>{
private:
  int index(int i1,int i2) const {
    assert (0<=i1 && i1<n1);
    assert (0<=i2 && i2<n2);
    return i2 + n2*i1;
  }

  int n1,n2;

public:
  array2(int n1_,int n2_ ): vector<T>(n1_*n2_)
  {resize(n1_,n2_);}

  array2() { n1=0; n2=0; }

  ~array2() {}
 
  void resize(int n1_,int n2_ ) {n1=n1_; n2=n2_; vector<T>::resize(n1*n2);}
  
  const T& elem(int i1,int i2) const {
    return vector<T>::operator[](index(i1,i2));
  }

  T& elem(int i1,int i2) {
    return vector<T>::operator[](index(i1,i2));
  }

  void print(ostream &out) const {
    print(out,0,0,n1,n2);
  }
  void print(ostream &out, int i0, int i1, int j0, int j1) const;
  
  void read_square(istream &in) {
    resize(0,0);
    T val;
    while (in>>val) {
      vector<T>::push_back(val);
    }
    int len=vector<T>::size();
    int n = (int)sqrt((double)len);
    resize(n,n);
  }

};

template <>
inline
void array2<float>::print(ostream &out, int i0, int i1, int j0, int j1) const{
  out <<"["<<i0<<".."<<j0-1<<"] x ["<<i1<<".."<<j1-1<<"]"<<endl;

  for (int i=i0;i<j0;i++) {
    for (int j=i1;j<j1;j++) {
	// out.form("%5.1f",elem(i,j)); out <<" ";
	out << elem(i,j) <<" ";
    }
    out <<endl;
  }
  out<<endl;
}

template <class T>
inline
void array2<T>::print(ostream &out, int i0, int i1, int j0, int j1) const{
  for (int i=i0;i<j0;i++) {
    for (int j=i1;j<j1;j++) {
      out << elem(i,j) <<" ";
    }
    out <<endl;
  }
  out<<endl;
}


#endif //  ARRAYS_HH
